<template>
  <div id="charts-container">
    <div class="row">
      <div class="col-md-6 top-chart" ref="topLeftChart" id="allStationsChart"></div>
      <div class="col-md-6 top-chart" ref="topRightChart" id="histogramChart"></div>
    </div>
    <div id="modals"></div>
    <div class="row mt-3">
      <div ref="mainChart" id="mainStationChart"></div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, onMounted, ref, watch } from "@vue/runtime-core";
import Plotly from "plotly.js-dist";
import { useStore } from '@/store';
import { colors } from '@/utils/_colors';
import { plotlyTrace } from '@/utils/_types';
import { makeTrendTrace, makeStationTrace, makeAllStationTrace, makeNormTrace, makeExtraStationTrace, makeLastYearRecordHistogram, getParameterLabel, getDataRange, makeSmoothTrace } from "./graph";

export default defineComponent({
    name: 'mainStationChart',
    setup: () => {
      /**
      * STORE
      */
      const store = useStore();
      const mainChart = ref('');
      const topRightChart = ref('');

      /**
      * CHART VARIABLES
      */
      const layout = {
        title: "Think of a title",
        showlegend: true,
        legend: {
          x: 0,
          xanchor: 'left',
          y: 1
        },
        xaxis: {
            rangemode: 'nonnegative',
            autorange: true,
            type: 'date',
        },
        yaxis: {
            range: getDataRange(store),
            type: 'linear',
            title: {
              text: getParameterLabel(store, store.state.selectedParameter),
            },
        },
        margin: {
            t: 0,
            pad: 20
        },
        autosize: true
      };

      const layoutHistogram = {
        title: `Concentration moy. de chaque captage au cours de la dernière année (${store.getters.getDataLastYear})`,
        annotations: [{
            x: store.getters.getLastYearAverageMainStation,
            y: 0,
            text: `${store.getters.getLastYearAverageMainStation} ${store.getters.getParameterUnit}`,
            showarrow: true,
            arrowhead: 7,
            arrowcolor: colors.red,
            ax: 0,
            ay: 25
          },
          {
            xref: 'paper',
            yref: 'paper',
            x: 0.02,
            xanchor: 'left',
            y: 1,
            yanchor: 'bottom',
            text: '◼ Moyenne du captage',
            showarrow: false,
            font: {
              family: 'Courier New, monospace',
              size: 11,
              color: colors.red
            },
          }],
        xaxis: {
          autorange: true,
          type: 'number',
          title: {
            text: getParameterLabel(store, store.state.selectedParameter),
          },
        },
        yaxis: {
          rangemode: 'nonnegative',
          title: {
            text: "Nombre de stations"
          }
        }
      }

      const config = { responsive: true };

     /**
      * watch
      */
      watch(() => [
        store.state.allStationsRecords,
        store.state.filteredRecords,
        store.state.filteredRecordsExtraStation,
        store.state.stationParameterTrend,
        store.state.extraStationParameterTrend,
        store.state.smoothData,
        store.state.extraSmoothData,
        store.state.showNorm,
      ], () => {

        const stationTrace = makeStationTrace(store);

        let plotData: plotlyTrace[] = [stationTrace];

        if (store.state.filteredRecordsExtraStation.length > 0) {
          const extraStationTrace = makeExtraStationTrace(store);
          plotData.push(extraStationTrace);
        }
        if (store.state.stationParameterTrend.length > 0) {
          const trendData = store.state.stationParameterTrend.filter((d) => new Date(d.date).getFullYear() >= store.state.timeInterval[0] && new Date(d.date).getFullYear() <= store.state.timeInterval[1]);
          if (trendData.length > 0) {
            const trendTrace = makeTrendTrace(store, trendData, colors["blue-trend"], store.state.selectedStationId);
            plotData.push(trendTrace);
          }
        }
        if (store.state.extraStationParameterTrend.length > 0) {
          const trendData = store.state.extraStationParameterTrend.filter((d) => new Date(d.date).getFullYear() >= store.state.timeInterval[0] && new Date(d.date).getFullYear() <= store.state.timeInterval[1]);
          console.log(trendData);
          if (trendData.length > 0) {
            const trendTrace = makeTrendTrace(store, trendData, colors["red-trend"], store.state.extraStationId);
            plotData.push(trendTrace);
          }
        }
        if (store.state.smoothData.length > 0) {
          const smoothData = store.state.smoothData.filter((d) => new Date(d.date).getFullYear() >= store.state.timeInterval[0] && new Date(d.date).getFullYear() <= store.state.timeInterval[1]);
          const smoothTrace = makeSmoothTrace(smoothData, colors['blue-smooth']);
          plotData.push(smoothTrace);
        }
        if (store.state.extraSmoothData.length > 0) {
          const smoothData = store.state.extraSmoothData.filter((d) => new Date(d.date).getFullYear() >= store.state.timeInterval[0] && new Date(d.date).getFullYear() <= store.state.timeInterval[1]);
          const extraSmoothTrace = makeSmoothTrace(smoothData, colors['red-smooth']);
          plotData.push(extraSmoothTrace);
        }
        if (store.state.showNorm) {
          const parameterForNorm = store.state.parameters.find((parameter) => parameter.id === store.state.selectedParameter)
          if ( parameterForNorm ) {
            const normTrace = makeNormTrace(store, parameterForNorm);
            plotData.push(normTrace);
          }
        }

        layout.yaxis.title.text = getParameterLabel(store, store.state.selectedParameter);
        layout.yaxis.range = getDataRange(store);

        makeMainChart(plotData, layout, config);

        const leftPlotData = [makeAllStationTrace(store)]
        leftPlotData.push(stationTrace);
        makeTopLeftChart(leftPlotData, layout, config);

        layoutHistogram.xaxis.title.text = getParameterLabel(store, store.state.selectedParameter);
        const rightPlotData = [makeLastYearRecordHistogram(store)];
        makeTopRightChart(rightPlotData, layoutHistogram, config);

        Plotly.moveTraces("mainStationChart", 1)
        Plotly.moveTraces("allStationsChart", 1)
      })

      /**
      * METHODS
      */

      const makeMainChart = (data, layout, config) => {
        Plotly.react("mainStationChart", data, layout, config)
      };
      const makeTopLeftChart = (data, layout, config) => {
        Plotly.react("allStationsChart", data, layout, config)
      };
      const makeTopRightChart = (data, layout, config) => {
        Plotly.react("histogramChart", data, layout, config)
      }

      onMounted(() => {
        const stationTrace = makeStationTrace(store);
        const smoothTrace = makeSmoothTrace(store.state.smoothData, colors.blue);
        makeMainChart([stationTrace, smoothTrace], layout, config);
        const leftPlotData = [stationTrace, makeAllStationTrace(store)];
        makeTopLeftChart(leftPlotData, layout, config);
        const rightPlotData = [makeLastYearRecordHistogram(store)];
        makeTopRightChart(rightPlotData, layoutHistogram, config);
      });

      return {
        mainChart,
        topRightChart,
      };
    }
})
</script>
